//+------------------------------------------------------------------+
//|                                            Price Close Alert.mq4 |
//|                                        Copyright  2007, SMJones |
//|                                            sjcoinc2000@yahoo.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, SMJones"
#property link      "sjcoinc2000@yahoo.com"

#property indicator_chart_window

extern int       TestPrice = PRICE_CLOSE;
extern int       InputMAval=10;
extern int       InputMAtype=1; // 0 for Simple (SMA), 1 for Exponential (EMA), 2 for Smoothed (SMMA), 3 for LWMA
extern int       InputMAshift=0;
extern int       InputMAprice=6; // 0=close, 1=open, 2=high, 3=low, 4=Median, 5=Typical, 6=Weighted

//extern double  PriceTest = 0.0;

extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsPushNotif = false;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern string soundFile       = "alert2.wav";

double state[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(1);
      SetIndexBuffer(0,state); SetIndexStyle(0,DRAW_NONE);
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   for (int i=limit;i>=0;i--)
   {
      double testprice = iMA(NULL, 0, 1         , 0           , MODE_SMA   , TestPrice   , i);
      double testma    = iMA(NULL, 0, InputMAval, InputMAshift, InputMAtype, InputMAprice, i);
      state[i] = state[i+1];
      if(testprice>testma) state[i] =  1;
      if(testprice<testma) state[i] = -1;
   }
   manageAlerts();
   return(0);
  }
//+------------------------------------------------------------------+

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (state[whichBar] != state[whichBar+1])
      {
         if (state[whichBar] ==  1) doAlert("up");
         if (state[whichBar] == -1) doAlert("down");
      }
   }
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message = Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" price crossed MA "+doWhat;
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(StringConcatenate(Symbol()," price cross ma "),message);
          if (alertsPushNotif) SendNotification(message);
          if (alertsSound)     PlaySound(soundFile);
   }
}

